Attribute VB_Name = "modMenu"
'Prfen, ob ein bestimmter String in einem anderen vorkommt (in diesem Fall fr das Men)
Public Function MenuExists(Searchstring As String, FindString) As Boolean
    Dim ParseMenuString As Long
    For ParseMenuString = 1 To (Len(Searchstring) - Len(FindString)) + 1
        If Mid$(Searchstring, ParseMenuString, Len(FindString)) = FindString Then
            MenuExists = True
        End If
    Next ParseMenuString
End Function

'Menhandles auslesen
Public Sub GetMenuHandles()
    Dim CheckMenuForItem As Long
    
    For CheckMenuForItem = 1 To UBound(MenuList)
        If MenuExists(MenuList(CheckMenuForItem).Text, "Mark all") Then
            MenuMarkAllHandle = MenuList(CheckMenuForItem).Id
        End If
        
        If MenuExists(MenuList(CheckMenuForItem).Text, "Alles markieren") Then
            MenuMarkAllHandle = MenuList(CheckMenuForItem).Id
        End If
        
        If MenuExists(MenuList(CheckMenuForItem).Text, "Copy") Then
            MenuCopyHandle = MenuList(CheckMenuForItem).Id
        End If
        
        If MenuExists(MenuList(CheckMenuForItem).Text, "Kopieren") Then
            MenuCopyHandle = MenuList(CheckMenuForItem).Id
        End If
        
        If MenuExists(MenuList(CheckMenuForItem).Text, "Edit") Then
            ParentMenuHandle = MenuList(CheckMenuForItem).Id
        End If
        
        If MenuExists(MenuList(CheckMenuForItem).Text, "Bearbeiten") Then
            ParentMenuHandle = MenuList(CheckMenuForItem).Id
        End If
    Next CheckMenuForItem
End Sub

'Mens in das Array MenuList einlesen
Sub List_Menu(ByVal hwnd, ByVal hmenu As Long, sys As Long)
    Dim menuID As Long
    Dim menuFlag As Long
    Dim menuCnt As Long
    Dim i As Long
    Dim ret As Long
    Dim Pos As Long
    Dim MenuText$
    Dim mText$
    Static Level As Long
    Static cnt As Long
    Dim ub As Long
    Dim subMenu As Long
    Const MF_BYPOSITION = 1024
    Const MF_BYCOMMAND = 0
    
    If hmenu = 0 Then
        If sys = True Then
            hmenu = GetSystemMenu(hwnd, 0)
        Else
            hmenu = GetMenu(hwnd)
        End If
        cnt = 0
        Level = 0
        MenuList(0).ParenthMenu = hmenu
    End If
    
    If hmenu <= 0 Then
        Exit Sub
    End If
    
    menuCnt = GetMenuItemCount(hmenu)
    If menuCnt < 0 Then
        MsgBox "Error"
        Exit Sub
    End If
    
    ub = UBound(MenuList)
    ReDim Preserve MenuList(ub + menuCnt)
    Level = Level + 1
    
    MenuText$ = String$(256, 0)
  
    For i = 0 To menuCnt - 1
        menuID = GetMenuItemID(hmenu, i)
        
        MenuText = String$(256, 0)
        Select Case menuID
            Case 0
                cnt = cnt + 1
                MenuList(cnt).Type = 0
            Case -1
                cnt = cnt + 1
                MenuList(cnt).Type = 1
                ret = GetMenuString(hmenu, i, MenuText, 127, MF_BYPOSITION)
                menuFlag = GetMenuState(hmenu, i, MF_BYPOSITION)
                
            Case Else
                cnt = cnt + 1
                ret = GetMenuString(hmenu, menuID, MenuText, 127, MF_BYCOMMAND)
                menuFlag = GetMenuState(hmenu, menuID, MF_BYCOMMAND)
                
                MenuList(cnt).Type = 2
          End Select
          
          If MenuList(cnt).Type > 0 Then
            Pos = InStr(1, MenuText$, Chr$(0), 1)
            mText$ = Left$(MenuText$, Pos - 1)
          End If
          MenuList(cnt).Id = menuID
          MenuList(cnt).ParentHwnd = hwnd
          MenuList(cnt).ParenthMenu = hmenu
          MenuList(cnt).Text = mText
          MenuList(cnt).Level = Level
          MenuList(cnt).Pos = i
                    
          If MenuList(cnt).Type = 1 Then
                subMenu = GetSubMenu(hmenu, i)
                menuCnt = GetMenuItemCount(subMenu)
                MenuList(cnt).nSub = menuCnt
                Call List_Menu(hwnd, subMenu, 0)
          End If
          
    Next i
    Level = Level - 1

End Sub


